--------------------------------------------------------------------------------
-- File: Patriot/Patriot.lua
-- Date: 23/11/09
--------------------------------------------------------------------------------

conf = {

-- ===============================================
-- Leader bonus game mode (IA)
-- The leader gets a big target on his head,
-- and you get bonus points for killing him.
-- ===============================================

LeaderMode = {
    Enabled = false;
    KillBonus = 5;
};

-- ===============================================
-- Zombie game mode (TIA)
-- 1 player is randomly selected as a zombie
-- All the other players start as survivors
-- Survivors spawn with normal weapons
-- Zombies can only punch.
-- Careful, zombies take less damage and do more!
-- If a zombie kills a survivor, they respawn as a zombie!
-- Survivors can optionally be highlighted
-- ===============================================

ZombieMode = {
    Enabled = false;
    HighlightSurvivors = true;
    ZombieDamageTakenMult = 0.5;
    ZombieMeleeDamageMult = 2.0;
};

-- ===============================================
-- spawn protection options
-- ===============================================

useNewSpawnSystem = true;
SpawnProtectTime = 0;

-- ===============================================
-- Game rules options
-- ===============================================

showDiscardedHits = true;
MaxAirPing = 275;
AirMinPlayers = 1;
NukeTime = 0;
falldmg = 0.00;
headshotOnly = false;

-- HQ auto turret settings
TurretsDestroyable = false;
TurretHP = 500;

-- Headquarters options
HQMsgOnHit = false;
HQHPMult = 1;

-- ===============================================
-- Multi kills
-- ===============================================

MultiKills = {
    Time = 4.0;
};

-- ===============================================
-- Minimum version for killstreak sounds
-- ===============================================

KillSoundVersion = {
    major = 0;
    minor = 708;
};

-- ===============================================
-- Version lockout
-- ===============================================

VersionLock = {
    Enabled = false;
    major = 0;
    minor = 701;
    message = "Update your Falcon mod to play on this server!";
};

-- ===============================================
-- Player Options
-- ===============================================
PlayerOptions = {
        ["10009999"] = {
            Name            =   "Test Admin";
            Admin           =   true;
            Moderator       =   false;
            ProtectName     =   true;
            ReservedSlot    =   true;
            Premium         =   true;
            ClanMember      =   true;
            };
        ["10009998"] = {
            Name            =   "Test Mod";
            Admin           =   false;
            Moderator       =   true;
            ProtectName     =   true;
            ReservedSlot    =   true;
            Premium         =   true;
            ClanMember      =   true;
            };
};

-- ===============================================
-- Map voting
-- ===============================================

MapVote = {
    cooldown = 300;
    duration = 60;
    messageInterval = 20;
    yesFraction = 0.5;
};

-- ===============================================
-- Name Options
-- ===============================================

ApplyCountryTag = false;
RenameNomads = true;
NomadNames = { "Vegeta", "Iron Man", "Batman", "Superman", "Luke Skywalker", "Han Solo", "Target Practice", "Nappa", "Yolo Tendencies", "Ben Dover" };

-- ===============================================
-- Stats system enable/disable
-- ===============================================

StatSystem = true;

-- ===============================================
-- Custom character models.
-- Requires the stats system to be enabled.
-- ===============================================

CustomCharVersion = {
    major = 0;
    minor = 711;
};

CustCharPSEnabled = true;

CustomCharTypes =
{
    ["nanosuit_us"]        = true,
    ["nanosuit_nk"]        = true,
    ["kyong"]              = true,
    ["prophet"]            = true,
    ["prophet_chute"]      = true,
    ["psycho"]             = true,
    ["psycho_helmet"]      = nil,
    ["hawker"]             = true,
    ["cortez"]             = true,
    ["morrison"]           = true,
    ["strickland"]         = true,
    ["keegan"]             = true,
    ["rosenthal"]          = true,
    ["scientist_mask"]     = true,

    ["grunt_nk_jungle_01"] = true,
    ["grunt_nk_jungle_02"] = true,
    ["grunt_nk_jungle_03"] = true,
    ["grunt_nk_jungle_04"] = true,
    ["grunt_nk_jungle_05"] = true,

    ["grunt_nk_camp_01"]   = true,
    ["grunt_nk_camp_02"]   = true,
    ["grunt_nk_camp_03"]   = true,

    ["grunt_us_01"]        = true,
    ["grunt_us_02"]        = true,
    ["grunt_us_03"]        = true,

    ["grunt_us_white_01"]  = true,
    ["grunt_us_white_02"]  = true,
    ["grunt_us_white_03"]  = true,
    ["grunt_us_white_04"]  = true,
    ["grunt_us_white_05"]  = true,
    ["grunt_us_white_06"]  = true,
    ["grunt_us_white_07"]  = true,
    ["grunt_us_white_08"]  = true,
    ["grunt_us_white_09"]  = true,
    ["grunt_us_white_10"]  = true,
    ["grunt_us_white_11"]  = true,

    ["grunt_us_black_01"]  = true,
    ["grunt_us_black_02"]  = true,
    ["grunt_us_black_03"]  = true,
    ["grunt_us_black_04"]  = true,
    ["grunt_us_black_05"]  = true,
    ["grunt_us_black_06"]  = true,
    ["grunt_us_black_07"]  = true,
    ["grunt_us_black_08"]  = true,
    ["grunt_us_black_09"]  = true,
    ["grunt_us_black_10"]  = true,
    ["grunt_us_black_11"]  = true,
    ["grunt_us_black_12"]  = true,
    ["grunt_us_black_13"]  = true,
    ["grunt_us_black_14"]  = true,

    ["officer_us_white"]   = true,
    ["officer_us_black"]  = true,

    ["sailor_us"]          = true,

    ["pilot_us"]           = true,
    ["pilot_nk"]           = true,

    ["firefighter"]        = true,
    ["firefighter_silver"] = true,
    ["cleaner"]            = true,

    ["deckhand_blue"]      = true,
    ["deckhand_brown"]     = true,
    ["deckhand_purple"]    = true,
    ["deckhand_green"]     = true,
    ["deckhand_red"]       = true,
    ["deckhand_white"]     = true,
    ["deckhand_yellow"]    = true,
};

-- ===============================================
-- Logging options
-- ===============================================
LogOptions = {

    ConnectionLog = {
        FileLog             =   false;              --Logs connections and disconnections in a seperate file //Logs/%TIMESTAMP%-Connection.log    (true or false)
        ServerLogEntry      =   true;               --Logs connections and disconnections into the server.log file.                               (true or false)
        ChatAnnounce        =   true;               --Announces connections and disconnections into chat (requires ChatEntity)                    (true or false)
    };

    ChatLogging = {
        FileLog             =   false;              --Logs chat in a seperate file //Logs/%TIMESTAMP%-Chat.log                        (true or false)
        AdminConsole        =   true;               --Logs chat into Admin's Console (including chat they shouldn't normally see)     (true or false)
        PlayerConsole       =   true;               --Logs chat into each player's console. (Similar to SSM)                          (true or false)
    };

    HitLogging = {
        FileLog             =   false;              --Logs Hits in a seperate file //Logs/%TIMESTAMP%-Hits.log              (true or false)
        AdminConsole        =   true;               --Logs Hits into Admin's Console                                        (true or false)
        PlayerConsole       =   false;              --Logs Hits into each player's console. (Only hits related to them)     (true or false)
    };

    CheatLogging = {
        FileLog             =   true;               --Logs Hackers in a seperate file //Logs/%TIMESTAMP%-Hackers.log    (true or false)
        AdminConsole        =   true;               --Logs Hackers into Admin's Console                                 (true or false)
        ChatAnnounce        =   true;               --Announces Hackers into chat (requires ChatEntity)                 (true or false)
        AutoBanHacker       =   true;               --Automatically bans any hackers that Phoenix catches               (true or false)
    };
};

-- ===============================================
-- CTF Game mode
-- ===============================================

CTFMode = {
    Enabled = false;
    NKFlag = {
        class = "TACGun_Fleet";
        position = {1212.64, 1548.18, 115.95};
        orientation = {0.0107975, 0.999942, 0};
        name = "NK_FLAG";
    };
    USFlag = {
        class = "TACGun_Fleet";
        position = {1187.5, 1589, 103.579};
        orientation = {0.0127484, -0.999919, 0};
        name = "US_FLAG";
    };
    ReturnTimeout = 15;
    CapAreaRadius = 3;
};

-- ===============================================
-- Gungame
-- ===============================================
gunGame = {
    weaponOrder = {
        {{ class = "GaussRifle", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "DSG1", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "Hurricane", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "AlienMount", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "SCAR", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "FY71", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "SMG", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "Shotgun", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "SCAR", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "FY71", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "SMG", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "AY69", attachments = {"LAM"}, attach = true }, { class = "AY69", attachments = {"LAM"}, attach = true }},
        {{ class = "SOCOM", attachments = {"LAM"}, attach = true }, { class = "SOCOM", attachments = {"LAM"}, attach = true }},
        {{ class = "AY69", attachments = {"LAM"}, attach = true }},
        {{ class = "SOCOM", attachments = {"LAM"}, attach = true }},
        {{ class = "AY69", attachments = {"LAM"}, attach = true }},
        {{ class = "SOCOM", attachments = {"LAM"}, attach = true }, { class = "SOCOM", attachments = {"LAM"}, attach = true }},
        {{ class = "AY69", attachments = {"LAM"}, attach = true }, { class = "AY69", attachments = {"LAM"}, attach = true }},
        {{ class = "SMG", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "FY71", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "SCAR", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "Shotgun", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "FY71", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "SMG", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "SCAR", attachments = {"LAMRifle", "Silencer"}, attach = true }},
        {{ class = "AlienMount", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "Hurricane", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "DSG1", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "GaussRifle", attachments = {"LAMRifle"}, attach = true }},
        {{ class = "TACGun", attachments = {}, attach = false }},
    };
    Enabled = false;
};

-- ===============================================
-- Artillery chatcommand
-- ===============================================
Artillery =
{
    -- call-in cost
    Cost = 800;
    -- usage cooldown in minutes
    Cooldown = 2;

    -- max active strikes per team
    MaxConcurrentStrikes = 1;

    StrikesActive =
    {
        -- NK
        [1] = 0,
        -- US
        [2] = 0,
    };
};

-- ===============================================
-- Player Options Settings
-- ===============================================

    PremiumOptions = {
        PremiumTag          =   "[PREMIUM]";
        AutoAddPremiumTag   =   false;
        PremiumTagAsPrefix  =   true;
    };

    ClanOptions = {
        ClanTag             =   "[Tag]";
        ClanTagAsPrefix     =   true;
        AutoAddClanTag      =   false;
    };

    ReservedSlotsOptions = {
        KickMessageOne      =   "Sorry, You are queued to be kicked for reserved slots in 30 seconds.";        --Chat Message to player
        KickMessageTwo      =   "Please visit http://your-site-here.com for more info!";                       --Chat Message to player
        AmountOfSlots       =   0;                                                                             --Amount of slots reserved
    };

-- ===============================================
-- Player Weapon Equips
-- ===============================================
WeaponEquips = {

        Standard = {
            Weapons = {
                "SMG",
                "SCAR",
                "SCAR",
            };
            Attachments = {
                ["SCAR"] = {
                    "LAMRifle",
                    --"AssaultScope",
                };
                ["SMG"] = {
                    "LAMRifle",
                };
                ["DSG1"] = {
                    "LAMRifle", "SniperScope",
                };
            };
        };

        Premium = {
            Weapons = {
                "SMG",
                "SCAR",
                "SCAR",
            };
            Attachments = {
                ["SCAR"] = {
                    "LAMRifle",
                    --"AssaultScope",
                };
                ["SMG"] = {
                    "LAMRifle",
                };
                ["DSG1"] = {
                    "LAMRifle", "SniperScope",
                };
            };
        };

};
-- ===============================================
-- Kill Options
-- ===============================================
KillOptions = { 

        KillStreaks = {
            Messages = {
                MessageAll = {
                    Standard = "%s IS %s!";     --Message sent to all players on a killstreak
                    Headshots = "";             --Message sent to all players on a killstreak
                };
                MessageKiller = {
                    Standard = "YOU ARE %s";    --message sent to player on a killstreak
                    Headshots = "";             --message sent to player on a killstreak
                };
            };

            Standard = {
                    [5] = {
                            name = "ON A KILLING SPREE",
                    };
                    [10] = {
                            name = "ON A RAMPAGE!",
                    };
                    [15] = {
                            name = "DOMINATING!!",
                    };
                    [20] = {
                            name = "UNSTOPPABLE!!!",
                    };
                    [25] = {
                            name = "GODLIKE!!!!",
                    };
                    [30] = {
                            name = "WICKED SICK!!!!!",
                    };
            };
        };
        FirstBlood = {
            MessageAll =  "%s DREW FIRST BLOOD!";
            MessageKiller = "FIRST BLOOD!!!";
        };
};

-- ===============================================
-- In-Game Administrator Options
-- ===============================================

    Admins = {
        AllowInvincibility  = {
            Tag             =   "[ADMIN]";                              --Tag added before an admin's name when they activate invincibility.    (String)
            AddTag          =   false;                                  --Add tag when admin is Invincible                                      (true or false)
            MessageOnHit     =   "ADMIN IS IN INVINCIBILITY MODE!";     --Message sent to shooter when admin is hit.                            (String)
        };
        Immume = {
            TeamkillPenalty =   true;                                   --Makes Admins immume to Teamkiller Handlers (such as kick or PenaltyBox)    (true or false)
            Autobalance        =   true;                                --Makes Admins immute to autobalance.                                        (true or false)
        };
        ConsoleCommands     =   true;                                   --Allows the use of in-game console commands. (ConsoleCommands will NOT load if false, preventing Server-side entry aswell!)    (true or false)
    };

-- ===============================================
-- Message Spam
-- ===============================================

    MessageSpam = nil; --[[{
        Delay = 9000;
        Messages = {
            "This server allows wall jump! Download the mod from jedi95.com",
            "Type !commands for a list of chat commands.",
            "This server tracks your career stats! Use !stats to check yours or !top to see the top 10 players.",
        };
    };]]--

-- ===============================================
-- Chat Options
-- ===============================================
ChatOptions = {

    ChatEntity = {
        Name = "SERVER:";       --Name of the ChatEntity, ChatEntity is required for the server to "Talk"       (String)
        KDRMessage = false;     --Chat message informing players of their Kill/Death ratio when it changes.     (true or false)
    };

    ChatCommands = {
        AdminCommands = true;    --Allows the use of administrative-only commands.        (true or false)
        HideInChat = true;       --Hides from chat when commands are executed.            (true or false)
                                 --Please See ChatCommands.lua for a list of commands.
    };

    ChatMute = {
        Message = "You have been muted";    --Message sent to player when muted.    (String)
        MuteTime = 5;                       --Default time to mute a player for.    (Number)
    };
};

-- ===============================================
-- Specific Chat Command Options
-- ===============================================

    TransferCommandLimits = {
        TimeLimit = 300;            --Number in seconds between each max command use
        MaxUsage = 0;               --Max uses of the command
    };

    ResetCommandLimits = {
        TimeLimit = 0;              --Number in seconds between each command use
    };

    RenameCommandLimits = {
        TimeLimit = 0;              --Number in seconds between each max command use
    };

    PMCommandLimits = {
        TimeLimit = 0;              --Number in seconds between each max command use
    };

-- ===============================================
-- Vehicle Options
-- ===============================================

    VehicleLocks = true;                    --Allow vehicle locking. (Requires ChatCommands) (true or false)
    VehiclePPShare = nil;--[[{
        killerAmount = 1.0;                 --Percentage of PP gained. (number 0 through 1)
        supportAmount = 0.25;               --Percentage of PP gained. (number 0 through 1)
    };]]--

-- ===============================================
-- Defending Points
-- ===============================================

    DefencePoints = nil;--[[{
        EnergySites = false;            --Get points for defending EnergySites (true or false)
        Bunkers = false;                --Get points for defending Bunkers (true or false)
    };]]--

-- ===============================================
-- Misc. Options
-- ===============================================

    mapAbandonTime = nil;           --Set to an number in seconds. After 0 players for that many seconds, the next level will load. (Suggest: 300 (5 minutes)) (Number)

-- ===============================================
-- Custom vehicle setup
-- ===============================================
BuyMessages = {

WelcomeMessage = nil; --"Open console with [^] or [~] to view list of custom vehicles";

    Air = {
        "=======================================================================================",
        "AIR FACTORY:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "      Spawn VTOL                   1000                    spawnvtol";
        "      Spawn Helicopter             900                     spawnheli";
        "=======================================================================================",
    };
--[[
    Naval = {
        "=======================================================================================",
        "NAVAL FACTORY:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    SmallWar = {
        "=======================================================================================",
        "SMALL WAR FACTORY:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    BigWar = {
        "=======================================================================================",
        "BIG WAR FACTORY:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    Proto = {
        "=======================================================================================",
        "PROTOTYPE FACTORY:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    Bunker = {
        "=======================================================================================",
        "BUNKER:",
        "------Item Name--------------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    SpawnTruck = {
        "=======================================================================================",
        "SPAWNTRUCK:",
        "------Item Name--------------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };
    Base = {
        "=======================================================================================",
        "BASE:",
        "------Vehicle Name-----------------Price-------------------Buy Command-----------------",
        "";
        "";
        "";
        "=======================================================================================",
    };]]--
};

--================================================
};  --END of conf.
-- ===============================================
-- Individual Level Setups
-- ===============================================

LevelSetup["multiplayer/ps/beach"] = function (name)
    conf.SpawnProtectTime = 1;
    local ps = g_gameRules;
    local bl = ps.buyList; 

    bl.haxvtol = {
        id="haxvtol",
        name="Hax_VTOL",
        price=10000,
        class="US_vtol",
        modification="VTOL_Ascension",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=30,
        category="@mp_catVehicles",
        loadout=0,
    };
    bl.spawnvtol = {
        id="spawnvtol",
        name="Spawn_VTOL",
        price=1000,
        class="US_vtol",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };
    bl.spawnheli = {
        id="spawnheli",
        name="Spawn_Helicopter",
        price=900,
        class="Asian_helicopter",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };

    for i,fac in ipairs(g_gameRules.factories) do
        local kv = fac.vehicles;

        if (kv.us4wd) then
            -- light or heavy vehicle factory
            -- kv.moarltv = true;
            -- Log("[Patriot] added MOAR Car to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.nktank) then
            -- heavy vehicle factory
            -- kv.gaussaaa = true;
            -- Log("[Patriot] added Gauss AAA to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.ustactank) then
            -- proto factory large map
            -- kv.singtank = true;
            -- Log("[Patriot] added Singularity Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end 
        if (kv.nktactank) then
            -- proto factory small map
            -- kv.moactank = true;
            -- Log("[Patriot] added MOAC Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.usvtol) then
            -- air factory / carrier
            kv.haxvtol = true;
            kv.spawnvtol = true;
            kv.spawnheli = true;
            Log("[Patriot] added Spawn VTOL/Heli to %q #%s",fac:GetName(),tostring(fac.id));
        end
    end
end

LevelSetup["multiplayer/ps/coast_ps"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/crossroads"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/frost"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/gaza"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/highway1.1"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/jungle"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/mesa"] = function (name)
    conf.SpawnProtectTime = 1;
    local ps = g_gameRules;
    local bl = ps.buyList;

    bl.haxvtol = {
        id="haxvtol",
        name="Hax_VTOL",
        price=10000,
        class="US_vtol",
        modification="VTOL_Ascension",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=30,
        category="@mp_catVehicles",
        loadout=0,
    };
    bl.spawnvtol = {
        id="spawnvtol",
        name="Spawn_VTOL",
        price=1000,
        class="US_vtol",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };
    bl.spawnheli = {
        id="spawnheli",
        name="Spawn_Helicopter",
        price=900,
        class="Asian_helicopter",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };

    for i,fac in ipairs(g_gameRules.factories) do
        local kv = fac.vehicles;

        if (kv.us4wd) then
            -- light or heavy vehicle factory
            -- kv.moarltv = true;
            -- Log("[Patriot] added MOAR Car to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.nktank) then
            -- heavy vehicle factory
            -- kv.gaussaaa = true;
            -- Log("[Patriot] added Gauss AAA to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.ustactank) then
            -- proto factory large map
            -- kv.singtank = true;
            -- Log("[Patriot] added Singularity Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.nktactank) then
            -- proto factory small map
            -- kv.moactank = true;
            -- Log("[Patriot] added MOAC Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.usvtol) then
            -- air factory / carrier
            kv.haxvtol = true;
            kv.spawnvtol = true;
            kv.spawnheli = true;
            Log("[Patriot] added Spawn VTOL/Heli to %q #%s",fac:GetName(),tostring(fac.id));
        end
    end
end

LevelSetup["multiplayer/ps/plantation"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/refinery"] = function (name)
    conf.SpawnProtectTime = 1;
    local ps = g_gameRules;
    local bl = ps.buyList; 

    for i,fac in ipairs(g_gameRules.factories) do
        local kv = fac.vehicles;

        if (kv.us4wd) then
            -- light or heavy vehicle factory
            -- kv.moarltv = true;
            Log("[Patriot] removed light tanks from %q #%s",fac:GetName(),tostring(fac.id));
            kv.usgauss4wd = false;
            kv.usasv = false;
        end
        if (kv.nktank) then
            -- heavy vehicle factory
            -- kv.gaussaaa = true;
            Log("[Patriot] removed tanks from %q #%s",fac:GetName(),tostring(fac.id));
            kv.usgauss4wd = false;
            kv.nkaaa = false;
            kv.usasv = false;
            kv.usapc = false;
            kv.nkapc = false;
            kv.nktank = false;
            kv.ustank = false;
            --kv.usgausstank = false;
        end
        if (kv.ustactank) then
            -- proto factory large map
            -- kv.singtank = true;
            -- Log("[Patriot] added Singularity Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end 
        if (kv.nktactank) then
            -- proto factory small map
            -- kv.moactank = true;
            -- Log("[Patriot] added MOAC Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.usvtol) then
            -- air factory / carrier
        end
    end
end

LevelSetup["multiplayer/ps/refinery_esl"] = function (name)
    conf.SpawnProtectTime = 1;
    local ps = g_gameRules;
    local bl = ps.buyList; 

    for i,fac in ipairs(g_gameRules.factories) do
        local kv = fac.vehicles;

        if (kv.us4wd) then
            -- light or heavy vehicle factory
            -- kv.moarltv = true;
            Log("[Patriot] removed light tanks from %q #%s",fac:GetName(),tostring(fac.id));
            kv.usgauss4wd = false;
            kv.usasv = false;
        end
        if (kv.nktank) then
            -- heavy vehicle factory
            -- kv.gaussaaa = true;
            Log("[Patriot] removed tanks from %q #%s",fac:GetName(),tostring(fac.id));
            kv.usgauss4wd = false;
            kv.nkaaa = false;
            kv.usasv = false;
            kv.usapc = false;
            kv.nkapc = false;
            kv.nktank = false;
            kv.ustank = false;
            --kv.usgausstank = false;
        end
        if (kv.ustactank) then
            -- proto factory large map
            -- kv.singtank = true;
            -- Log("[Patriot] added Singularity Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end 
        if (kv.nktactank) then
            -- proto factory small map
            -- kv.moactank = true;
            -- Log("[Patriot] added MOAC Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.usvtol) then
            -- air factory / carrier
        end
    end
end

LevelSetup["multiplayer/ps/shore"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ps/tarmac"] = function (name)
    conf.SpawnProtectTime = 1;
    local ps = g_gameRules;
    local bl = ps.buyList;

    bl.haxvtol = {
        id="haxvtol",
        name="Hax_VTOL",
        price=10000,
        class="US_vtol",
        modification="VTOL_Ascension",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=30,
        category="@mp_catVehicles",
        loadout=0,
    };
    bl.spawnvtol = {
        id="spawnvtol",
        name="Spawn_VTOL",
        price=1000,
        class="US_vtol",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };
    bl.spawnheli = {
        id="spawnheli",
        name="Spawn_Helicopter",
        price=900,
        class="Asian_helicopter",
        modification="Spawn",
        vehicle=true,
        teamlimit=1,
        abandon=0,
        buildtime=20,
        category="@mp_catVehicles",
        loadout=0,
        spawngroup=true,
        buyzoneradius=11,
        servicezoneradius=11,
        buyzoneflags=bor(bor(PowerStruggle.BUY_AMMO, PowerStruggle.BUY_WEAPON), PowerStruggle.BUY_EQUIPMENT),
    };

    for i,fac in ipairs(g_gameRules.factories) do
        local kv = fac.vehicles;

        if (kv.us4wd) then
            -- light or heavy vehicle factory
            -- kv.moarltv = true;
            -- Log("[Patriot] added MOAR Car to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.nktank) then
            -- heavy vehicle factory
            -- kv.gaussaaa = true;
            -- Log("[Patriot] added Gauss AAA to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.ustactank) then
            -- proto factory large map
            -- kv.singtank = true;
            -- Log("[Patriot] added Singularity Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.nktactank) then
            -- proto factory small map
            -- kv.moactank = true;
            -- Log("[Patriot] added MOAC Tank to %q #%s",fac:GetName(),tostring(fac.id));
        end
        if (kv.usvtol) then
            -- air factory / carrier
            --kv.haxvtol = true;
            --kv.spawnvtol = true;
            --kv.spawnheli = true;
            --Log("[Patriot] added Spawn VTOL/Heli to %q #%s",fac:GetName(),tostring(fac.id));
        end
    end
end

LevelSetup["multiplayer/ps/training"] = function (name)
    conf.SpawnProtectTime = 1;
end

LevelSetup["multiplayer/ia/ctf_mirror"] = function (name)
    conf.CTFMode = {
        Enabled = true;
        NKFlag = {
            class = "TACGun_Fleet";
            position = {131.4946,101.6108,24.75};
            orientation = {0.0107975, 0.999942, 0};
            name = "NK_FLAG";
        };
        USFlag = {
            class = "TACGun_Fleet";
            position = {131.5407,156.4199,24.75};
            orientation = {0.0127484, -0.999919, 0};
            name = "US_FLAG";
        };
        ReturnTimeout = 15;
        CapAreaRadius = 1;
    };
end

LevelSetup["multiplayer/ia/sang9_aimgauss"] = function (name)
    conf.WeaponEquips = {
        Standard = {
            Weapons = {
                "GaussRifle",
            };
            Attachments = {
                ["GaussRifle"] = {
                    "LAMRifle",
                };
            };
        };

        Premium = {
            Weapons = {
                "GaussRifle",
            };
            Attachments = {
                ["GaussRifle"] = {
                    "LAMRifle",
                };
            };
        };
    };
end

LevelSetup["multiplayer/ia/dsg_1_aim"] = function (name)
    conf.WeaponEquips = {
        Standard = {
            Weapons = {
                "DSG1",
            };
            Attachments = {
                ["DSG1"] = {
                    "LAMRifle",
                };
            };
        };

        Premium = {
            Weapons = {
                "DSG1",
            };
            Attachments = {
                ["DSG1"] = {
                    "LAMRifle",
                };
            };
        };
    };
end

LevelSetup["multiplayer/ia/dsg_aim2"] = function (name)
    conf.WeaponEquips = {
        Standard = {
            Weapons = {
                "DSG1",
            };
            Attachments = {
                ["DSG1"] = {
                    "LAMRifle",
                };
            };
        };

        Premium = {
            Weapons = {
                "DSG1",
            };
            Attachments = {
                ["DSG1"] = {
                    "LAMRifle",
                };
            };
        };
    };
end

LevelSetup["multiplayer/ia/jump_4"] = function (name)
    conf.isJumpMap = true;
    conf.WeaponEquips = nil;
end

LevelSetup["multiplayer/ia/jump_3"] = function (name)
    conf.isJumpMap = true;
    conf.WeaponEquips = nil;
end

LevelSetup["multiplayer/ia/jump_n_punch"] = function (name)
    conf.isJumpMap = true;
    conf.WeaponEquips = nil;
end

LevelSetup["multiplayer/ia/parkour"] = function (name)
    conf.isJumpMap = true;
    conf.WeaponEquips = nil;
end

LevelSetup["multiplayer/ia/tankwars"] = function (name)
    conf.isJumpMap = true;
end

LevelSetup["multiplayer/ia/amc-q3dm17"] = function (name)
    conf.isJumpMap = true;
end

LevelSetup["multiplayer/ia/facing_worlds"] = function (name)
    conf.isJumpMap = true;
end

LevelSetup["multiplayer/ia/deck-16"] = function (name)
    conf.isJumpMap = true;
end

LevelSetup["multiplayer/ia/war"] = function (name)
    conf.isJumpMap = true;
end